/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.enums.EnumAccesslevel;
import de.ship.db.tables.records.VCoreRightElementRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VCoreRightElement extends TableImpl<VCoreRightElementRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_core_right_element</code>
     */
    public static final VCoreRightElement V_CORE_RIGHT_ELEMENT = new VCoreRightElement();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VCoreRightElementRecord> getRecordType() {
        return VCoreRightElementRecord.class;
    }

    /**
     * The column <code>common_dd.v_core_right_element.key_element</code>.
     */
    public final TableField<VCoreRightElementRecord, Integer> KEY_ELEMENT = createField(DSL.name("key_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_right_element.fk_usnr</code>.
     */
    public final TableField<VCoreRightElementRecord, Integer> FK_USNR = createField(DSL.name("fk_usnr"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_right_element.shippie_acl</code>.
     */
    public final TableField<VCoreRightElementRecord, EnumAccesslevel> SHIPPIE_ACL = createField(DSL.name("shippie_acl"), SQLDataType.VARCHAR.asEnumDataType(EnumAccesslevel.class), this, "");

    /**
     * The column <code>common_dd.v_core_right_element.shipdesigner_acl</code>.
     */
    public final TableField<VCoreRightElementRecord, EnumAccesslevel> SHIPDESIGNER_ACL = createField(DSL.name("shipdesigner_acl"), SQLDataType.VARCHAR.asEnumDataType(EnumAccesslevel.class), this, "");

    /**
     * The column <code>common_dd.v_core_right_element.square_acl</code>.
     */
    public final TableField<VCoreRightElementRecord, EnumAccesslevel> SQUARE_ACL = createField(DSL.name("square_acl"), SQLDataType.VARCHAR.asEnumDataType(EnumAccesslevel.class), this, "");

    private VCoreRightElement(Name alias, Table<VCoreRightElementRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VCoreRightElement(Name alias, Table<VCoreRightElementRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_core_right_element" as  SELECT h.key_element,
         u.fk_usnr,
         u.shippie_acl,
         u.shipdesigner_acl,
         u.square_acl
        FROM (common_dd.t_core_userprivilege u
          JOIN common_dd.t_core_element_hierarchy h ON ((h.fk_privilege = u.fk_privilege)));
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_core_right_element</code> table
     * reference
     */
    public VCoreRightElement(String alias) {
        this(DSL.name(alias), V_CORE_RIGHT_ELEMENT);
    }

    /**
     * Create an aliased <code>common_dd.v_core_right_element</code> table
     * reference
     */
    public VCoreRightElement(Name alias) {
        this(alias, V_CORE_RIGHT_ELEMENT);
    }

    /**
     * Create a <code>common_dd.v_core_right_element</code> table reference
     */
    public VCoreRightElement() {
        this(DSL.name("v_core_right_element"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VCoreRightElement as(String alias) {
        return new VCoreRightElement(DSL.name(alias), this);
    }

    @Override
    public VCoreRightElement as(Name alias) {
        return new VCoreRightElement(alias, this);
    }

    @Override
    public VCoreRightElement as(Table<?> alias) {
        return new VCoreRightElement(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreRightElement rename(String name) {
        return new VCoreRightElement(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreRightElement rename(Name name) {
        return new VCoreRightElement(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreRightElement rename(Table<?> name) {
        return new VCoreRightElement(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreRightElement where(Condition condition) {
        return new VCoreRightElement(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreRightElement where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreRightElement where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreRightElement where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreRightElement where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreRightElement where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreRightElement where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreRightElement where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreRightElement whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreRightElement whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
